diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererCreeper.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererCreeper.java
index 97ee97b94..ed5a936cf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererCreeper.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererCreeper.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.entity.monster.MobCreeper;
@@ -7,7 +8,6 @@ import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.models.entity.BoneTransform;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
@@ -33,20 +33,16 @@ public class MobRendererCreeper extends MobRenderer<MobCreeper> {
             model = getModel("charged");
             bindTexture("/assets/minecraft/textures/armor/power.png");
             final float ticks = creeper.tickCount + partialTick;
-            GL11.glMatrixMode(GL11.GL_TEXTURE);
-            GL11.glLoadIdentity();
+            GLRenderer.textureM4f().identity();
             final float _x = ticks * 0.01F;
             final float _y = ticks * 0.01F;
-            GLRenderer.modelM4f().translate(_x, _y, 0.0F);
-            GL11.glMatrixMode(GL11.GL_MODELVIEW);
+            GLRenderer.textureM4f().translate(_x, _y, 0.0F);
             GLRenderer.enableState(State.BLEND);
             GLRenderer.setColor4f(0.5f, 0.5f, 0.5f, 1.0F);
             GLRenderer.globalSetLightEnabled(false);
-            GL11.glBlendFunc(GL11.GL_ONE, GL11.GL_ONE);
+            GLRenderer.setBlendFunc(BlendFactor.ONE, BlendFactor.ONE);
         } else if (layer == 2) { // Reset funky powered rendering
-            GL11.glMatrixMode(GL11.GL_TEXTURE);
-            GL11.glLoadIdentity();
-            GL11.glMatrixMode(GL11.GL_MODELVIEW);
+            GLRenderer.textureM4f().identity();
             GLRenderer.globalSetLightEnabled(true);
             GLRenderer.disableState(State.BLEND);
             return null;
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
index a73472626..da5b77a44 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
@@ -80,11 +80,6 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player> {
             GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
             GLRenderer.enableState(State.BLEND);
             GLRenderer.disableState(State.CULL_FACE);
-//            if (mc.isAmbientOcclusionEnabled()) {
-//                GL11.glShadeModel(GL11.GL_SMOOTH);
-//            } else {
-//                GL11.glShadeModel(GL11.GL_FLAT);
-//            }
             GLRenderer.modelM4f().scale(0.55f, -0.55f, 0.55f);
             GLRenderer.modelM4f().translate(0, -0.75f, -0.75f);
 
@@ -110,10 +105,6 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player> {
             }
 
             GLRenderer.popFrame();
-//            GL11.glEnable(GL_LIGHTING);
-//            GL11.glEnable(GL_LIGHT0);
-//            GL11.glEnable(GL_LIGHT1);
-//            GL11.glEnable(GL_COLOR_MATERIAL);
         }
     }
 
@@ -143,7 +134,6 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player> {
                     final FontRenderer font = getFont();
                     GLRenderer.pushFrame();
                     GLRenderer.modelM4f().translate((float) x + 0.0F, (float) y + 2.3F, (float) z);
-//                    GL11.glNormal3f(0.0F, 1.0F, 0.0F);
                     GLRenderer.modelM4f().rotateY(org.joml.Math.toRadians(-this.renderDispatcher.viewLerpYaw));
                     GLRenderer.modelM4f().rotateX(org.joml.Math.toRadians(this.renderDispatcher.viewLerpPitch));
                     GLRenderer.modelM4f().scale(-f1, -f1, f1);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererQuadruped.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererQuadruped.java
index 21007b1af..12ada44a4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererQuadruped.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererQuadruped.java
@@ -6,7 +6,6 @@ import net.minecraft.core.entity.animal.MobCow;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.models.entity.BoneTransform;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSlime.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSlime.java
index e493129a8..d0cfdd623 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSlime.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSlime.java
@@ -19,7 +19,6 @@ public class MobRendererSlime extends MobRenderer<MobSlime> {
     @Override
     protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final MobSlime entity, final float brightness, final float partialTick, final int layer) {
         final StaticEntityModel model = getModel("main");
-//        GL11.glEnable(GL12.GL_NORMALIZE);
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSpider.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSpider.java
index fb07dd858..0a7269b45 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSpider.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSpider.java
@@ -8,7 +8,6 @@ import net.minecraft.core.entity.monster.MobSpider;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.models.entity.BoneTransform;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
index 6413e042e..f3e27b964 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
@@ -125,11 +125,9 @@ public class MobRendererWolf extends MobRenderer<MobWolf> {
             GLRenderer.pushFrame();
             getModel("main").translateToBone("mouthItem");
             GLRenderer.modelM4f().scale(MobRenderer.ENTITY_RENDER_SCALE, -MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE);
-//            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
             GLRenderer.enableState(State.BLEND);
             ItemModelDispatcher.getInstance().getDispatch(itemstack).render(GLRenderer.getTessellator(), entity, itemstack, DisplayPos.GROUND, Minecraft.getMinecraft().gameSettings.items3D.value, 1, entity.getLightmap(partialTick), partialTick, true);
             GLRenderer.disableState(State.BLEND);
-//            GL11.glDisable(GL12.GL_RESCALE_NORMAL);
             GLRenderer.popFrame();
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
index 650aa367e..f0f09125d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
@@ -44,7 +44,6 @@ public abstract class ItemModel {
     }
 
     public void renderItemEntity(@NotNull TessellatorGeneral tessellator, @NotNull ItemStack itemStack, boolean items3d, int clusterSize, int ticks, float yaw, int lightmap, float partialTick) {
-//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         GLRenderer.enableState(State.BLEND);
         if (items3d) {
             GLRenderer.modelM4f().rotateY(Math.toRadians(yaw));
@@ -53,7 +52,6 @@ public abstract class ItemModel {
         }
         render(tessellator, null, itemStack, DisplayPos.GROUND, items3d, clusterSize, lightmap, partialTick, false);
         GLRenderer.disableState(State.BLEND);
-//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
     public void renderFirstPerson(@NotNull TessellatorGeneral tessellator, @NotNull ItemRenderer itemRenderer, @NotNull Player player, @NotNull ItemStack itemStack, int lightmapCoord, float partialTick) {
@@ -61,7 +59,6 @@ public abstract class ItemModel {
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         GLRenderer.enableState(State.CULL_FACE);
-//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         final float swingProgress = player.getSwingProgress(partialTick);
         final float animationProgress2 = MathHelper.sin(swingProgress * MathHelper.PI);
         final float animationProgress = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
@@ -103,7 +100,6 @@ public abstract class ItemModel {
             render(tessellator,player, itemStack, DisplayPos.FIRST_PERSON_RIGHT_HAND, true, 1, lightmapCoord, partialTick, false);
         }
         GLRenderer.popFrame();
-//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
     public abstract IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack);
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
index a42708629..98ee01810 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelBlock.java
@@ -102,12 +102,10 @@ public class ItemModelBlock extends ItemModelStandard {
             super.renderItemEntity(tessellator, itemStack, items3d, clusterSize, ticks, yaw, lightmap, partialTick);
             return;
         }
-//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         GLRenderer.enableState(State.BLEND);
         GLRenderer.modelM4f().rotateY(Math.toRadians(yaw));
         render(tessellator, null, itemStack, DisplayPos.GROUND, items3d, clusterSize, lightmap, partialTick, false);
         GLRenderer.disableState(State.BLEND);
-//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
index b522f4f53..47d32d723 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
@@ -36,7 +36,6 @@ public class ItemModelMap extends ItemModelStandard {
         // The map renders very differently from any other item, so has its own custom first person render code
         if (ItemMap.hasInitialized(itemStack)) {
             GLRenderer.pushFrame();
-//            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
 
             final float rotationPitch = player.xRotO + (player.xRot - player.xRotO) * partialTick;
             final float swingProgress = player.getSwingProgress(partialTick);
@@ -50,7 +49,6 @@ public class ItemModelMap extends ItemModelStandard {
             GLRenderer.modelM4f().translate(0.0F, (-(1.0F - itemRenderer.getEquippedProgress(partialTick)) * 1.2F - f_val * 0.5F) + 0.04F, zOff); // Place map at right distance from camera
             GLRenderer.modelM4f().rotateY(Math.PI_OVER_2_f);
             GLRenderer.modelM4f().rotateZ(Math.toRadians(f_val * -85F));
-//            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
 
             // Render both player arms
             this.mc.textureManager.bindDownloadableTexture(this.mc.thePlayer.skinURL, this.mc.thePlayer.getEntityTexture(), this.mc.thePlayer.slimModel ? PlayerSkinParser.instanceAlex : PlayerSkinParser.instanceSteve);
@@ -104,8 +102,6 @@ public class ItemModelMap extends ItemModelStandard {
             final float scale2 = 0.015625F;
             GLRenderer.modelM4f().scale(scale2, scale2, scale2);
 
-//            GL11.glNormal3f(0.0F, 0.0F, -1F);
-
             // Render paper background of map
             this.mc.textureManager.bindTexture(this.mc.textureManager.loadTexture("/assets/minecraft/textures/misc/mapbg.png"));
             tessellator.startDrawingQuads();
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
index 4caa237e7..85db19ea1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
@@ -206,16 +206,13 @@ public class ItemModelStandard extends ItemModel{
         final int a = (int) (alpha * 255.0f);
         if (itemstack.stackSize != 1 || override != null) {
             final String s = override != null ? override : "" + itemstack.stackSize;
-//            GL11.glDisable(GL_LIGHTING);
             GLRenderer.disableState(State.DEPTH_TEST);
             fontRenderer.render(s, (x + 19) - 2 - fontRenderer.stringWidth(s), y + 6 + 3).setShadow().setColor(0xffffff | (a << 24)).call();
-//            GL11.glEnable(GL_LIGHTING);
             GLRenderer.enableState(State.DEPTH_TEST);
         }
         if (itemstack.isItemDamaged() || itemstack.getItem().showFullDurability()) {
             final int barWidth = (int) Math.round(13D - (itemstack.getItemDamageForDisplay() * 13D) / itemstack.getMaxDamage());
             final int progress = (int) Math.round(255D - (itemstack.getItemDamageForDisplay() * 255D) / itemstack.getMaxDamage());
-//            GL11.glDisable(GL_LIGHTING);
             GLRenderer.pushFrame();
             GLRenderer.disableState(State.DEPTH_TEST);
             GLRenderer.setShader(Shaders.COLOR);
@@ -227,7 +224,6 @@ public class ItemModelStandard extends ItemModel{
             renderColoredQuad(tessellator, x + 2, y + 13, barWidth, 1, colorFG, a);
             tessellator.draw();
             GLRenderer.popFrame();
-//            GL11.glEnable(GL_LIGHTING);
         }
         GLRenderer.popFrame();
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java b/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
index a25931e65..5b0a84583 100644
--- a/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
@@ -11,13 +11,7 @@ import net.minecraft.client.render.tessellator.TessellatorShader;
 import net.minecraft.client.render.uniform.UniformBlockManager;
 import net.minecraft.core.util.helper.Color;
 import org.jetbrains.annotations.NotNull;
-import org.joml.Matrix4f;
-import org.joml.Matrix4fStack;
-import org.joml.Vector3dc;
-import org.joml.Vector3fc;
-import org.joml.Vector4dc;
-import org.joml.Vector4f;
-import org.joml.Vector4fc;
+import org.joml.*;
 import org.lwjgl.BufferUtils;
 import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
@@ -74,6 +68,7 @@ public class GLRenderer {
     private final @NotNull Matrix4fStack projectionMatrixStack = new Matrix4fStack(RENDER_FRAMES_STACK_SIZE);
     private final @NotNull Matrix4fStack viewMatrixStack = new Matrix4fStack(RENDER_FRAMES_STACK_SIZE);
     private final @NotNull Matrix4fStack modelMatrixStack = new Matrix4fStack(RENDER_FRAMES_STACK_SIZE);
+    private final @NotNull Matrix4fStack textureMatrixStack = new Matrix4fStack(RENDER_FRAMES_STACK_SIZE);
 
     private final long[] stateConfigStack = new long[RENDER_FRAMES_STACK_SIZE];
     private long currentStateConfig = State.DITHER.bitMask | State.MULTISAMPLE.bitMask; // Spec says these two are default on https://docs.gl/gl4/glEnable
@@ -141,8 +136,8 @@ public class GLRenderer {
         shader.bind();
         if (instance.viewProjMatDirty) {
             GL41.glBindBuffer(GL41.GL_UNIFORM_BUFFER, UniformBlockManager.BLOCK_MATRICES.ubo);
-            UniformBlockManager.BLOCK_MATRICES.adapter.bufferData(projectionM4f(), 0, UniformBlockManager.BLOCK_MATRICES.buffer.clear());
-            UniformBlockManager.BLOCK_MATRICES.adapter.bufferData(projectionM4f().invert(matBuf), N * 4 * 4, UniformBlockManager.BLOCK_MATRICES.buffer);
+            UniformBlockManager.BLOCK_MATRICES.adapter.bufferData(projectionM4f(), N * 4 * 4 * 0, UniformBlockManager.BLOCK_MATRICES.buffer.clear());
+            UniformBlockManager.BLOCK_MATRICES.adapter.bufferData(projectionM4f().invert(matBuf), N * 4 * 4 * 1, UniformBlockManager.BLOCK_MATRICES.buffer);
             UniformBlockManager.BLOCK_MATRICES.adapter.bufferData(viewM4f(), N * 4 * 4 * 2, UniformBlockManager.BLOCK_MATRICES.buffer);
             UniformBlockManager.BLOCK_MATRICES.adapter.bufferData(viewM4f().invert(matBuf), N * 4 * 4 * 3, UniformBlockManager.BLOCK_MATRICES.buffer);
             GL41.glBufferSubData(GL41.GL_UNIFORM_BUFFER, 0, UniformBlockManager.BLOCK_MATRICES.buffer);
@@ -150,6 +145,7 @@ public class GLRenderer {
             instance.viewProjMatDirty = false;
         }
         shader.uniformMat4f("model", modelM4f());
+        shader.uniformMat4f("texture", textureM4f());
 
         shader.uniformVec4f("uColor", Color.redFromInt(instance.currentColor)/255f, Color.greenFromInt(instance.currentColor)/255f, Color.blueFromInt(instance.currentColor)/255f, Color.alphaFromInt(instance.currentColor)/255f);
         shader.uniformFloat("uCurrentTick", instance.mc.ticksRan + instance.mc.timer.partialTicks);
@@ -228,6 +224,10 @@ public class GLRenderer {
         return instance.modelMatrixStack;
     }
 
+    public static @NotNull Matrix4f textureM4f() {
+        return instance.textureMatrixStack;
+    }
+
     public static void setShader(@NotNull Shader shader) {
         instance.currentShader = shader;
     }
@@ -432,6 +432,7 @@ public class GLRenderer {
         instance.projectionMatrixStack.pushMatrix();
         instance.viewMatrixStack.pushMatrix();
         instance.modelMatrixStack.pushMatrix();
+        instance.textureMatrixStack.pushMatrix();
     }
 
     public static void popFrame() {
@@ -454,6 +455,7 @@ public class GLRenderer {
         instance.projectionMatrixStack.popMatrix();
         instance.viewMatrixStack.popMatrix();
         instance.modelMatrixStack.popMatrix();
+        instance.textureMatrixStack.popMatrix();
 
         long newConfig = instance.stateConfigStack[instance.stackIndex];
         State.setStateConfig(instance.currentStateConfig, newConfig);
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java b/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java
index 64b6c53c3..abc00a79b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/Shader.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.render.shader;
 
-import static org.lwjgl.opengl.GL20.*;
+import static org.lwjgl.opengl.GL41.*;
 
 import java.nio.FloatBuffer;
 
@@ -9,17 +9,14 @@ import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
 import net.minecraft.client.render.OpenGLHelper;
 import org.jetbrains.annotations.NotNull;
-import org.joml.Matrix4fc;
-import org.joml.Vector2fc;
-import org.joml.Vector3fc;
-import org.joml.Vector4fc;
+import org.joml.*;
 import org.lwjgl.BufferUtils;
 import org.lwjgl.opengl.GL41;
 import org.slf4j.Logger;
 
 public class Shader {
     protected static final Logger LOGGER = LogUtils.getLogger();
-    private static final FloatBuffer mat4fBuf = BufferUtils.createFloatBuffer(16);
+    private static final FloatBuffer mat4fBuf = BufferUtils.createFloatBuffer(4 * 4);
     protected int program;
 
     protected int vertexShader;
diff --git a/game/client/src/main/java/net/minecraft/client/render/shader/ShaderGeometry.java b/game/client/src/main/java/net/minecraft/client/render/shader/ShaderGeometry.java
index 78f642142..d8b58e921 100644
--- a/game/client/src/main/java/net/minecraft/client/render/shader/ShaderGeometry.java
+++ b/game/client/src/main/java/net/minecraft/client/render/shader/ShaderGeometry.java
@@ -2,25 +2,25 @@ package net.minecraft.client.render.shader;
 
 import net.minecraft.client.render.OpenGLHelper;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL32;
-
-import static org.lwjgl.opengl.GL11.GL_TRUE;
-import static org.lwjgl.opengl.GL20.GL_COMPILE_STATUS;
-import static org.lwjgl.opengl.GL20.GL_FRAGMENT_SHADER;
-import static org.lwjgl.opengl.GL20.GL_INFO_LOG_LENGTH;
-import static org.lwjgl.opengl.GL20.GL_LINK_STATUS;
-import static org.lwjgl.opengl.GL20.GL_VERTEX_SHADER;
-import static org.lwjgl.opengl.GL20.glAttachShader;
-import static org.lwjgl.opengl.GL20.glCompileShader;
-import static org.lwjgl.opengl.GL20.glCreateProgram;
-import static org.lwjgl.opengl.GL20.glCreateShader;
-import static org.lwjgl.opengl.GL20.glDeleteShader;
-import static org.lwjgl.opengl.GL20.glGetProgramInfoLog;
-import static org.lwjgl.opengl.GL20.glGetProgrami;
-import static org.lwjgl.opengl.GL20.glGetShaderInfoLog;
-import static org.lwjgl.opengl.GL20.glGetShaderi;
-import static org.lwjgl.opengl.GL20.glLinkProgram;
-import static org.lwjgl.opengl.GL20.glShaderSource;
+import org.lwjgl.opengl.GL41;
+
+import static org.lwjgl.opengl.GL41.GL_TRUE;
+import static org.lwjgl.opengl.GL41.GL_COMPILE_STATUS;
+import static org.lwjgl.opengl.GL41.GL_FRAGMENT_SHADER;
+import static org.lwjgl.opengl.GL41.GL_INFO_LOG_LENGTH;
+import static org.lwjgl.opengl.GL41.GL_LINK_STATUS;
+import static org.lwjgl.opengl.GL41.GL_VERTEX_SHADER;
+import static org.lwjgl.opengl.GL41.glAttachShader;
+import static org.lwjgl.opengl.GL41.glCompileShader;
+import static org.lwjgl.opengl.GL41.glCreateProgram;
+import static org.lwjgl.opengl.GL41.glCreateShader;
+import static org.lwjgl.opengl.GL41.glDeleteShader;
+import static org.lwjgl.opengl.GL41.glGetProgramInfoLog;
+import static org.lwjgl.opengl.GL41.glGetProgrami;
+import static org.lwjgl.opengl.GL41.glGetShaderInfoLog;
+import static org.lwjgl.opengl.GL41.glGetShaderi;
+import static org.lwjgl.opengl.GL41.glLinkProgram;
+import static org.lwjgl.opengl.GL41.glShaderSource;
 
 public class ShaderGeometry extends Shader{
 
@@ -43,7 +43,7 @@ public class ShaderGeometry extends Shader{
 
         this.vertexShader = glCreateShader(GL_VERTEX_SHADER);
         this.fragmentShader = glCreateShader(GL_FRAGMENT_SHADER);
-        this.geometryShader = glCreateShader(GL32.GL_GEOMETRY_SHADER);
+        this.geometryShader = glCreateShader(GL41.GL_GEOMETRY_SHADER);
 
         glShaderSource(this.vertexShader, vertexSource);
         glShaderSource(this.fragmentShader, fragmentSource);
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/RenderList.java b/game/client/src/main/java/net/minecraft/client/render/terrain/RenderList.java
index 622154ca5..185e3bde5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/RenderList.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/RenderList.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.render.terrain;
 
-import static org.lwjgl.opengl.GL15.*;
+import static org.lwjgl.opengl.GL41.*;
 
 import java.nio.IntBuffer;
 import java.util.ArrayList;
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java
index f75ee716b..c0a63d84d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/VertexBuffer.java
@@ -1,13 +1,12 @@
 package net.minecraft.client.render.terrain;
 
-import static org.lwjgl.opengl.GL15.*;
+import static org.lwjgl.opengl.GL41.*;
 
 import java.util.ArrayList;
 import java.util.List;
 
 import com.mojang.logging.CategorizedLogger;
 import com.mojang.logging.LogUtils;
-import org.lwjgl.opengl.GL31;
 
 import net.minecraft.client.render.OpenGLHelper;
 import org.lwjgl.opengl.GL41;
@@ -132,13 +131,13 @@ public class VertexBuffer {
 		
 		OpenGLHelper.checkError("create expand buffer");
 
-        glBindBuffer(GL31.GL_COPY_READ_BUFFER, this.vbo);
-        glBindBuffer(GL31.GL_COPY_WRITE_BUFFER, newBuffer);
+        glBindBuffer(GL41.GL_COPY_READ_BUFFER, this.vbo);
+        glBindBuffer(GL41.GL_COPY_WRITE_BUFFER, newBuffer);
 
-        GL31.glCopyBufferSubData(GL31.GL_COPY_READ_BUFFER, GL31.GL_COPY_WRITE_BUFFER, 0, 0, this.capacity);
+        GL41.glCopyBufferSubData(GL41.GL_COPY_READ_BUFFER, GL41.GL_COPY_WRITE_BUFFER, 0, 0, this.capacity);
 
-        glBindBuffer(GL31.GL_COPY_READ_BUFFER, 0);
-        glBindBuffer(GL31.GL_COPY_WRITE_BUFFER, 0);
+        glBindBuffer(GL41.GL_COPY_READ_BUFFER, 0);
+        glBindBuffer(GL41.GL_COPY_WRITE_BUFFER, 0);
 
         OpenGLHelper.checkError("copy buffer");
 		
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java b/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java
index d97e8f693..c6c90092a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/Texture.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.render.texture;
 
 import static net.minecraft.client.util.helper.Buffer.buffer;
-import static org.lwjgl.opengl.GL11.*;
-import static org.lwjgl.opengl.GL12.GL_CLAMP_TO_EDGE;
-import static org.lwjgl.opengl.GL12.GL_TEXTURE_MAX_LEVEL;
+import static org.lwjgl.opengl.GL41.*;
+import static org.lwjgl.opengl.GL41.GL_CLAMP_TO_EDGE;
+import static org.lwjgl.opengl.GL41.GL_TEXTURE_MAX_LEVEL;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.GLAllocation;
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
index 79a43b13a..689925dbf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
@@ -42,7 +42,6 @@ public class TileEntityRendererFlag extends TileEntityRenderer<TileEntityFlag> {
     private long lastTick = 0;
 
     public void doRender(final @NotNull TessellatorGeneral tessellator, final @NotNull TileEntityFlag tileEntityFlag, final double x, final double y, final double z, final float partialTick, final boolean shortPole, final float windDirection, final float windIntensity) {
-//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         final World theWorld = this.mc.currentWorld;
         if (theWorld.getWorldTime() != this.lastTick) {
             this.lastTick = theWorld.getWorldTime();
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
index 90869313a..d1351e425 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
@@ -2,17 +2,15 @@ package net.minecraft.client.render.tileentity;
 
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityFlowerJar;
-import org.lwjgl.opengl.GL11;
 
-import static org.lwjgl.opengl.GL11.GL_BLEND;
-import static org.lwjgl.opengl.GL11.GL_ONE_MINUS_SRC_ALPHA;
-import static org.lwjgl.opengl.GL11.GL_SRC_ALPHA;
 
 public class TileEntityRendererFlowerJar extends TileEntityRenderer<TileEntityFlowerJar> {
 
@@ -26,12 +24,12 @@ public class TileEntityRendererFlowerJar extends TileEntityRenderer<TileEntityFl
             float scaleValue = 0.75F;
             GLRenderer.modelM4f().scale(scaleValue, scaleValue, scaleValue);
             GLRenderer.modelM4f().translate(0.66F, 0.75F, 0.66F);
-            GL11.glEnable(GL_BLEND);
-            GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
             Lighting.disable();
             BlockModelDispatcher.getInstance().getDispatch(block).renderStandalone(tessellator, tileEntity.flowerData, tileEntity.worldObj.getLightmapCoord(tileEntity.x, tileEntity.y, tileEntity.z, 0));
             Lighting.enableLight();
-            GL11.glDisable(GL_BLEND);
+            GLRenderer.disableState(State.BLEND);
         }
         GLRenderer.popFrame();
     }
